using UnityEngine;
using System.Collections;

public class Controller : MonoBehaviour
{
	public bool canControl;
	public bool follow;

	public Transform TeleportPoint;
	public Transform PlayerPoint;
	public Transform SheepPoint;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start ()
	{
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");

		canControl = false;
		follow = false;

		Camera.main.transform.position = TeleportPoint.position;
		Player.transform.position = PlayerPoint.position;
		Sheep.transform.position = SheepPoint.position;
	}
	
	// Update is called once per frame
	void Update () {
		if ( follow )
		{
			transform.position = new Vector3(Player.transform.position.x - 12f, transform.position.y, Player.transform.position.z - 24f);
		}

		if ( Input.GetButtonDown("Fire1") && canControl )
		{
			Vector3 position = Input.mousePosition;

			RaycastHit hit;
			Ray ray = Camera.main.ScreenPointToRay(position); 
			if ( Physics.Raycast(ray, out hit, Mathf.Infinity) )
			{
				if ( Vector3.Distance(hit.point, Player.transform.position) >= 3 )
				{
					Player.SendMessage("MoveToPoint", hit.point);
					Player.SendMessage("PlaySound");
				}
			}
		}
	}
}
