using UnityEngine;
using System.Collections;

public class Flower : MonoBehaviour {

	public Collider HubTrigger2;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start () {
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update ()
	{
		transform.LookAt(Camera.main.transform);
		transform.eulerAngles = new Vector3(26.56f, 206.56f, transform.eulerAngles.z);
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Camera.main.GetComponent<GameMenu>().gameState = 4;

			// Enable all endgame triggers
			// Tagged with "SearchTrigger"
			GameObject[] gos;
			gos = GameObject.FindGameObjectsWithTag("SearchTrigger");

			foreach (GameObject go in gos) {
				if ( go.collider.isTrigger )
				{
					go.collider.enabled = true;
				}
			}

			HubTrigger2.enabled = true;

			Player.SendMessage("SetTextDelay", 0f);
			Player.SendMessage("SetTextDuration", 3f);
			Player.SendMessage("UpdateText", "< I think sheep will love this flower! >");

			Destroy(Sheep);
			Destroy(gameObject);
		}
	}
}
