using UnityEngine;
using System.Collections;

public class GameMenu : MonoBehaviour {

	public Transform Game1Point;
	public Transform Game2Point;
	public Transform Game3Point;

	public bool showMenu;
	public int menuState;
	public int gameState;

	public int game1Count = 0;
	public int game2Count = 0;
	public int game3Count = 0;

	public bool searchRace = false;
	public bool searchHideSeek = false;

	Transform playerPoint;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start ()
	{
		showMenu = false;
		menuState = 0;
		gameState = 0;

		searchRace = false;
		searchHideSeek = false;

		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}

	void Update ()
	{
		// Increment game state
		if ( (game1Count == game2Count) && (game2Count == game3Count) && (game3Count == game1Count) && game1Count > gameState && game2Count > gameState && game3Count > gameState )
			gameState++;
	}
	
	void OnGUI ()
	{
		if ( showMenu )
		{
			if ( menuState == 0 )
			{
				// if ( GUI.Button (new Rect(Screen.width / 2 - 50, Screen.height / 2 - 200, 100, 100), "Let's cook\npeachcakes!") )
					// RunGame(gameState, 0);

				if ( game1Count <= gameState )
					if ( GUI.Button (new Rect(Screen.width / 2 - 175, Screen.height / 2 - 50, 100, 100), "Let's go\nexploring!") )
						RunGame(1);

				if ( game2Count <= gameState )
					if ( GUI.Button (new Rect(Screen.width / 2 - 50, Screen.height / 2 - 50, 100, 100), "Let's race to\nthe ocean!") )
						RunGame(2);

				if ( game3Count <= gameState )
					if ( GUI.Button (new Rect(Screen.width / 2 + 75, Screen.height / 2 - 50, 100, 100), "Let's play\nhide and seek!") )
						RunGame(3);
			}
		}
	}

	void RunGame(int gameID)
	{
		showMenu = false;
		string playerText = "";
		string sheepText = "!";

		switch (gameState)
		{
			case 0:
				sheepText = "!";
				break;
			case 1:
				sheepText = ". . .";
				break;
			case 2:
				switch (gameID)
				{
					case 0:
						sheepText = "I don't want to cook today, peach";
						break;
					case 1:
						sheepText = "I don't want to explore today, peach";
						game1Count++;
						break;
					case 2:
						sheepText = "I don't want to race today, peach";
						game2Count++;
						break;
					case 3:
						sheepText = "I don't want to play today, peach";
						game3Count++;
						break;
					default:
						Debug.Log("Something broke");
						break;
				}
				break;
			default:
				Debug.Log("Something broke");
				break;
		}

		switch (gameID)
		{
			case 0:
				playerText = "Let's cook peachcakes!";
				break;
			case 1:
				playerText = "Let's go exploring!";
				playerPoint = Game1Point;
				break;
			case 2:
				playerText = "Let's race to the ocean!";
				playerPoint = Game2Point;
				break;
			case 3:
				playerText = "Let's play hide and seek!";
				playerPoint = Game3Point;
				break;
			default:
				Debug.Log("Something broke");
				break;
		}

		Player.SendMessage("SetTextDelay", 0f);
		Player.SendMessage("SetTextDuration", 2.5);
		Player.SendMessage("UpdateText", playerText);

		Sheep.SendMessage("SetTextDelay", 3);
		Sheep.SendMessage("SetTextDuration", 2.5);
		Sheep.SendMessage("UpdateText", sheepText);

		StartCoroutine(UnlockPlayer(6f));
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);

		switch (gameState)
		{
			case 2:
				showMenu = true;
				break;
			case 3:
				Player.SendMessage("SetMoveState", true);
				Player.SendMessage("MoveToPoint", Vector3.zero);
				Camera.main.GetComponent<Controller>().canControl = true;

				Sheep.SendMessage("SetTargetState", false);
				Sheep.SendMessage("SetMoveState", false);

				StartCoroutine(State3Thought(2f));
				break;
			default:
				Player.SendMessage("SetMoveState", true);
				Player.SendMessage("MoveToPoint", playerPoint.position);
				Camera.main.GetComponent<Controller>().canControl = false;
				break;
		}
	}

	IEnumerator State3Thought(float wait)
	{
		yield return new WaitForSeconds(wait);

		Player.SendMessage("SetTextDelay", 0f);
		Player.SendMessage("SetTextDuration", 3.5);
		Player.SendMessage("UpdateText", "< I should go find sheep some flowers >\n< That will cheer her up! >");

		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);

		StartCoroutine(FreeMove(4f));
	}

	IEnumerator FreeMove(float wait)
	{
		yield return new WaitForSeconds(wait);

		Camera.main.GetComponent<Controller>().canControl = true;
		Camera.main.GetComponent<Controller>().follow = true;

		// Disable all gameplay type triggers
		// Tagged with "TriggerDisable"
		GameObject[] gos;
		gos = GameObject.FindGameObjectsWithTag("TriggerDisable");

		foreach (GameObject go in gos) {
			if ( go.collider.isTrigger )
			{
				// Debug.Log(go.name);
				go.collider.enabled = false;
			}
		}
	}
}
