using UnityEngine;
using System.Collections;

public class Explore : MonoBehaviour {

	public Transform TeleportPoint;
	public Transform PlayerPoint;
	public Transform SheepPoint;

	public GameObject FlowerBed;

	public GameObject Item1;
	public GameObject Item2;

	public Collider Item1Box;
	public Collider Item2Box;

	public GameObject Flower;

	public bool hasItem1 = false;
	public bool hasItem2 = false;

	GameObject Player;
	GameObject Sheep;

	bool ranStage1 = false;
	bool ranStage2 = false;

	// Use this for initialization
	void Start () {
		hasItem1 = false;
		hasItem2 = false;

		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");

		Item1.renderer.enabled = true;
		Item2.renderer.enabled = false;

		Item1Box.collider.enabled = true;
		Item2Box.collider.enabled = false;

		Flower.renderer.enabled = false;
		Flower.collider.enabled = false;

		FlowerBed.renderer.enabled = false;

		ranStage1 = false;
		ranStage2 = false;
	}
	
	// Update is called once per frame
	void Update ()
	{
		if ( !ranStage1 && hasItem1 )
		{
			// Increment times game is played
			Camera.main.GetComponent<GameMenu>().game1Count++;
			ranStage1 = true;

			StartCoroutine(EnableExit(1f));
		}

		if ( (ranStage1 && !ranStage2) && hasItem2 )
		{
			// Increment times game is played
			Camera.main.GetComponent<GameMenu>().game1Count++;
			ranStage2 = true;

			StartCoroutine(EnableExit(1f));
		}
	}

	IEnumerator EnableExit(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 3f);

		Camera.main.GetComponent<Controller>().follow = false;

		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", false);

		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
		Sheep.SendMessage("ChangeSpeed", 5f);

		StartCoroutine(MovePlayer(3f));
	}

	IEnumerator MovePlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 1f);

		Camera.main.transform.position = TeleportPoint.position;
		Player.transform.position = PlayerPoint.position;
		Sheep.transform.position = SheepPoint.position;

		if ( hasItem1 )
		{
			Item1.renderer.enabled = false;
			Item2.renderer.enabled = true;

			FlowerBed.renderer.enabled = true;
		}

		if ( hasItem2 )
		{
			Item2.renderer.enabled = false;
			Item2Box.collider.enabled = false;

			Flower.renderer.enabled = true;
			Flower.collider.enabled = true;
		}

		StartCoroutine(UnlockPlayer(1f));
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<Controller>().canControl = true;

		Player.SendMessage("MoveToPoint", Vector3.zero);
		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", true);

		Sheep.SendMessage("MoveToPoint", Vector3.zero);
		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
	}
}
