using UnityEngine;
using System.Collections;

public class ExploreStart : MonoBehaviour {

	public Collider Item1Box;
	public Collider Item2Box;
	public Collider Block;
	public Collider StartBlock;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start () {
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Block.collider.enabled = true;
			StartBlock.collider.enabled = false;

			Camera.main.GetComponent<Controller>().follow = true;
			Camera.main.GetComponent<Controller>().canControl = false;

			Player.SendMessage("SetTargetState", false);
			Player.SendMessage("SetMoveState", false);

			Sheep.SendMessage("SetTargetState", false);
			Sheep.SendMessage("SetMoveState", false);

			switch (Camera.main.GetComponent<GameMenu>().game1Count)
			{
				case 0:
					Sheep.SendMessage("SetTextDelay", 2f);
					Sheep.SendMessage("SetTextDuration", 2.5f);
					Sheep.SendMessage("UpdateText", "I wonder what we'll find today, peach!");

					Player.SendMessage("SetTextDelay", 5f);
					Player.SendMessage("SetTextDuration", 2.5f);
					Player.SendMessage("UpdateText", "I can't wait, sheep!");

					Item1Box.collider.enabled = true;
					Item2Box.collider.enabled = false;

					StartCoroutine(UnlockPlayer(8f));
					break;
				case 1:
					Player.SendMessage("SetTextDelay", 2f);
					Player.SendMessage("SetTextDuration", 2.5f);
					Player.SendMessage("UpdateText", "I wonder what we'll find today, sheep!");

					Sheep.SendMessage("SetTextDelay", 5f);
					Sheep.SendMessage("SetTextDuration", 2.5f);
					Sheep.SendMessage("UpdateText", ". . .");

					Item1Box.collider.enabled = false;
					Item2Box.collider.enabled = true;

					StartCoroutine(UnlockPlayer(8f));
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			collider.enabled = false;
		}
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);

		Camera.main.GetComponent<Controller>().canControl = true;
		Player.SendMessage("SetMoveState", true);
		Player.SendMessage("MoveToPoint", Vector3.zero);

		Sheep.SendMessage("SetMoveState", true);
		Sheep.SendMessage("MoveToPoint", Vector3.zero);
	}
}
