using UnityEngine;
using System.Collections;

public class HideSeek : MonoBehaviour {

	public Transform HidePoint1;
	public Transform HidePoint2;

	public Collider HideEnd1;
	public Collider HideEnd2;

	public Collider Block;

	int count;
	string text;

	GameObject Player;
	GameObject Sheep;

	Vector3 HidePosition;

	// Use this for initialization
	void Start ()
	{
		count = 0;
		text = "";

		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			/*
			Sheep.SendMessage("MoveToPoint", Vector3.zero);
			Sheep.SendMessage("SetTargetState", true);
			Sheep.SendMessage("SetMoveState", true);
			*/

			Block.collider.enabled = true;

			count = 0;
			switch (Camera.main.GetComponent<GameMenu>().game3Count)
			{
				case 0:
					text = "Okay peach, I'm going to go hide!";
					HidePosition = HidePoint1.position;
					HideEnd1.enabled = true;
					HideEnd2.enabled = false;
					break;
				case 1:
					text = "Okay peach, I'll go hide";
					HidePosition = HidePoint2.position;
					HideEnd1.enabled = false;
					HideEnd2.enabled = true;
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			Player.SendMessage("SetTargetState", false);
			Player.SendMessage("SetMoveState", false);

			Sheep.SendMessage("SetTargetState", false);
			Sheep.SendMessage("SetMoveState", false);

			Camera.main.GetComponent<Controller>().canControl = false;

			Sheep.SendMessage("SetTextDelay", 2f);
			Sheep.SendMessage("SetTextDuration", 2.5);
			Sheep.SendMessage("UpdateText", text);

			collider.enabled = false;
			StartCoroutine(DisplayText(5f));
		}
	}

	IEnumerator DisplayText(float wait)
	{
		yield return new WaitForSeconds(wait);
		count++;

		switch (count)
		{
			case 0:
				text = "Okay peach, I'm going to go hide!";
				break;
			case 1:
				text = "You have to come find me";
				break;
			case 2:
				text = "Ready?";
				break;
			case 3:
				break;
			default:
				Debug.Log("Something broke");
				break;
		}

		if ( count == 3 )
		{
			Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
			Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 1f);
			StartCoroutine(FadeIn(2f));
		}
		else
		{
			Sheep.SendMessage("SetTextDelay", 0f);
			Sheep.SendMessage("SetTextDuration", 2f);
			Sheep.SendMessage("UpdateText", text);

			StartCoroutine(DisplayText(2.5f));
		}
	}

	IEnumerator FadeIn(float wait)
	{
		yield return new WaitForSeconds(wait);

		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 1f);

		//TODO: Add more hide points
		Sheep.transform.position = HidePosition;

		Camera.main.GetComponent<Controller>().canControl = true;
		Camera.main.GetComponent<Controller>().follow = true;

		Player.SendMessage("MoveToPoint", Vector3.zero);
		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", true);
	}
}
