using UnityEngine;
using System.Collections;

public class HideSeekEnd : MonoBehaviour {

	public Transform TeleportPoint;
	public Transform PlayerPoint;
	public Transform SheepPoint;

	public Collider Block;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start () {
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Block.collider.enabled = false;

			Player.SendMessage("SetMoveState", false);

			Camera.main.GetComponent<Controller>().canControl = false;
			Camera.main.GetComponent<Controller>().follow = false;

			Sheep.SendMessage("MoveToPoint", Vector3.zero);
			Sheep.SendMessage("SetTargetState", true);
			Sheep.SendMessage("SetMoveState", true);

			switch (Camera.main.GetComponent<GameMenu>().game3Count)
			{
				case 0:
					Sheep.SendMessage("SetTextDelay", 2f);
					Sheep.SendMessage("SetTextDuration", 2.5);
					Sheep.SendMessage("UpdateText", "You found me, peach!");
					break;
				case 1:
					Player.SendMessage("SetTextDelay", 2f);
					Player.SendMessage("SetTextDuration", 2.5f);
					Player.SendMessage("UpdateText", "I found you, sheep!");
					break;
				default:
					Debug.Log("Something broke");
					break;
			}
			
			StartCoroutine(SayText(5f));
		}
	}

	IEnumerator SayText(float wait)
	{
		yield return new WaitForSeconds(wait);

		switch (Camera.main.GetComponent<GameMenu>().game3Count)
		{
				case 0:
					Sheep.SendMessage("SetTextDelay", 0f);
					Sheep.SendMessage("SetTextDuration", 5f);
					Sheep.SendMessage("UpdateText", "I love playing games with you");
					break;
				case 1:
					Player.SendMessage("SetTextDelay", 0f);
					Player.SendMessage("SetTextDuration", 5f);
					Player.SendMessage("UpdateText", "I love playing games with you");
					StartCoroutine(State2Thought(4f));
					break;
		}
		
		// Increment times game is played
		Camera.main.GetComponent<GameMenu>().game3Count++;
		StartCoroutine(EnableExit(8f));
	}

	IEnumerator State2Thought(float wait)
	{
		yield return new WaitForSeconds(wait);

		Sheep.SendMessage("SetTextDelay", 0f);
		Sheep.SendMessage("SetTextDuration", 2.5f);
		Sheep.SendMessage("UpdateText", ". . .");
	}

	IEnumerator EnableExit(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 3f);

		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", false);

		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);

		StartCoroutine(MovePlayer(3f));
	}

	IEnumerator MovePlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 1f);

		Camera.main.transform.position = TeleportPoint.position;
		Player.transform.position = PlayerPoint.position;
		Sheep.transform.position = SheepPoint.position;

		StartCoroutine(UnlockPlayer(1f));
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<Controller>().canControl = true;

		Player.SendMessage("MoveToPoint", Vector3.zero);
		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", true);

		Sheep.SendMessage("MoveToPoint", Vector3.zero);
		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
	}
}
