using UnityEngine;
using System.Collections;

public class Race : MonoBehaviour {

	public Transform RaceEnd;

	int count;
	string text;
	float newSpeed;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start ()
	{
		count = 0;
		text = "";
		newSpeed = 5f;

		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			count = 0;
			switch (Camera.main.GetComponent<GameMenu>().game2Count)
			{
				case 0:
					text = "Get ready to race!";
					newSpeed = 6.5f;
					break;
				case 1:
					text = "Are you ready, peach?";
					newSpeed = 5f;
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			Player.SendMessage("SetTargetState", false);
			Player.SendMessage("SetMoveState", false);

			Sheep.SendMessage("SetTargetState", false);
			Sheep.SendMessage("SetMoveState", false);

			Camera.main.GetComponent<Controller>().canControl = false;

			Sheep.SendMessage("SetTextDelay", 2f);
			Sheep.SendMessage("SetTextDuration", 2.5);
			Sheep.SendMessage("UpdateText", text);

			collider.enabled = false;
			StartCoroutine(DisplayText(5f));
		}
	}

	IEnumerator DisplayText(float wait)
	{
		yield return new WaitForSeconds(wait);
		count++;

		switch (count)
		{
			case 0:
				text = "Get ready . . .";
				break;
			case 1:
				text = "3 . . .";
				break;
			case 2:
				text = "2 . . .";
				break;
			case 3:
				text = "1 . . .";
				break;
			case 4:
				text = "Go ! ! !";
				break;
			default:
				Debug.Log("Something broke");
				break;
		}

		Sheep.SendMessage("SetTextDelay", 0f);
		Sheep.SendMessage("SetTextDuration", 0.9f);
		Sheep.SendMessage("UpdateText", text);

		if ( count == 4 )
		{
			Camera.main.GetComponent<Controller>().canControl = true;
			Player.SendMessage("SetMoveState", true);
			Player.SendMessage("MoveToPoint", Vector3.zero);

			Sheep.SendMessage("MoveToPoint", RaceEnd.position);
			Sheep.SendMessage("SetMoveState", true);
			Sheep.SendMessage("ChangeSpeed", newSpeed);
		}
		else
		{
			StartCoroutine(DisplayText(1f));
		}
	}
}
