using UnityEngine;
using System.Collections;

public class RaceEnd : MonoBehaviour {

	public Transform TeleportPoint;
	public Transform PlayerPoint;
	public Transform SheepPoint;

	public Transform RaceEndPoint;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start () {
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Player.SendMessage("MoveToPoint", Sheep.transform.position);
			Camera.main.GetComponent<Controller>().canControl = false;

			switch (Camera.main.GetComponent<GameMenu>().game2Count)
			{
				case 0:
					Sheep.SendMessage("SetTextDelay", 2f);
					Sheep.SendMessage("SetTextDuration", 5f);
					Sheep.SendMessage("UpdateText", "Isn't the ocean beautiful, peach?");
					break;
				case 1:
					Player.SendMessage("SetTextDelay", 2f);
					Player.SendMessage("SetTextDuration", 5f);
					Player.SendMessage("UpdateText", "Isn't the ocean beautiful, sheep?");

					Player.SendMessage("SetMoveState", true);
					Player.SendMessage("MoveToPoint", RaceEndPoint.position);

					Sheep.SendMessage("SetMoveState", true);
					Sheep.SendMessage("MoveToPoint", Vector3.zero);

					StartCoroutine(State2Thought(4f));
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			// Increment times game is played
			Camera.main.GetComponent<GameMenu>().game2Count++;

			StartCoroutine(EnableExit(8f));
		}
	}

	IEnumerator State2Thought(float wait)
	{
		yield return new WaitForSeconds(wait);

		Sheep.SendMessage("SetTextDelay", 0f);
		Sheep.SendMessage("SetTextDuration", 2.5f);
		Sheep.SendMessage("UpdateText", ". . .");
	}

	IEnumerator EnableExit(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 3f);

		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", false);

		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
		Sheep.SendMessage("ChangeSpeed", 5f);

		StartCoroutine(MovePlayer(3f));
	}

	IEnumerator MovePlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 1f);

		Camera.main.transform.position = TeleportPoint.position;
		Player.transform.position = PlayerPoint.position;
		Sheep.transform.position = SheepPoint.position;

		StartCoroutine(UnlockPlayer(1f));
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<Controller>().canControl = true;

		Player.SendMessage("MoveToPoint", Vector3.zero);
		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", true);

		Sheep.SendMessage("MoveToPoint", Vector3.zero);
		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
	}
}
