using UnityEngine;
using System.Collections;

public class Title : MonoBehaviour
{
	public Texture Titlecard;
	public Texture Creditcard;

	bool showTitle = true;
	public bool showCredit = true;
	bool adjustVolume = false;
	public bool fadeMusicOut = false;

	// Use this for initialization
	void Start () {
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<Controller>().canControl = false;

		showTitle = true;
		showCredit = false;
		adjustVolume = false;
		fadeMusicOut = false;

		StartCoroutine(DisableTitle(5f));
		StartCoroutine(StartFade(3f));
	}
	
	// Update is called once per frame
	void Update () {
		if ( adjustVolume )
		{
			audio.volume += 0.05f * Time.deltaTime;

			if ( audio.volume >= 0.2f )
			{
				audio.volume = 0.2f;
				adjustVolume = false;
			}
		}

		if ( fadeMusicOut )
		{
			audio.volume -= 0.05f * Time.deltaTime;

			if ( audio.volume <= 0f )
			{
				audio.volume = 0f;
				fadeMusicOut = false;
			}
		}
	}

	void OnGUI ()
	{
		if ( showTitle )
		{
			Rect rect = new Rect(0, Screen.height / 4, Screen.width, Screen.height / 2);
			GUI.depth = -1001;
			GUI.DrawTexture (rect, Titlecard, ScaleMode.ScaleToFit, true);
		}

		if ( showCredit )
		{
			Rect rect = new Rect(0, Screen.height - 160, Screen.width / 2, Screen.height / 4);
			GUI.depth = -1001;
			GUI.DrawTexture (rect, Creditcard, ScaleMode.ScaleToFit, true);
		}
	}

	IEnumerator DisableTitle(float wait)
	{
		yield return new WaitForSeconds(wait);
		showTitle = false;
		Camera.main.GetComponent<Controller>().canControl = true;
	}

	IEnumerator StartFade(float wait)
	{
		yield return new WaitForSeconds(wait);
		adjustVolume = true;
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 5f);
	}
}
