using UnityEngine;
using System.Collections;

public class Exit : MonoBehaviour
{
	public Transform TeleportPoint;
	public Transform PlayerPoint;
	public Transform SheepPoint;

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start ()
	{
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");
	}
	
	// Update is called once per frame
	void Update ()
	{
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
			Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 1f);

			Player.SendMessage("SetTargetState", false);
			Player.SendMessage("SetMoveState", false);

			Sheep.SendMessage("SetTargetState", false);
			Sheep.SendMessage("SetMoveState", false);

			StartCoroutine(MovePlayer(1f));
		}
	}

	IEnumerator MovePlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.black);
		Camera.main.GetComponent<CameraFade>().StartFade(Color.clear, 1f);

		Camera.main.transform.position = TeleportPoint.position;
		Player.transform.position = PlayerPoint.position;
		Sheep.transform.position = SheepPoint.position;

		// StartCoroutine(UnlockPlayer(1f));
	}

	IEnumerator UnlockPlayer(float wait)
	{
		yield return new WaitForSeconds(wait);
		Player.SendMessage("MoveToPoint", Vector3.zero);
		Player.SendMessage("SetTargetState", false);
		Player.SendMessage("SetMoveState", false);

		Sheep.SendMessage("SetTargetState", false);
		Sheep.SendMessage("SetMoveState", false);
	}
}
