using UnityEngine;
using System.Collections;

public class Hub2 : MonoBehaviour {

	public Transform SearchPoint1;
	public Transform SearchPoint2;
	public Transform SearchPoint3;
	public Transform TeleportPoint;

	GameObject Player;
	Vector3 searchPosition;
	int searchID = 1;
	bool hasFaded = false;

	bool GameOver = false;

	// Use this for initialization
	void Start () {
		Player = GameObject.Find("Player");
		searchPosition = SearchPoint1.position;
		hasFaded = false;

		GameOver = false;

		searchID = 1;
	}
	
	// Update is called once per frame
	void Update () {
		float distance = Vector3.Distance(searchPosition, Player.transform.position);
		string text = "";

		if ( GameOver && distance <= 3 )
		{
			switch (searchID)
			{
				case 1:
					text = ". . . Sheep?";
					searchPosition = SearchPoint2.position;
					StartCoroutine(ChangePosition(3f));
					break;
				case 2:
					text = "I have some flowers for you, sheep!";
					searchPosition = SearchPoint3.position;
					StartCoroutine(ChangePosition(3f));
					break;
				case 3:
					text = "Sheep, where are you?";
					searchPosition = SearchPoint1.position;
					StartCoroutine(ChangePosition(3f));
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			Player.SendMessage("SetTextDelay", 1f);
			Player.SendMessage("SetTextDuration", 2.5f);
			Player.SendMessage("UpdateText", text);
		}
	}

	IEnumerator ChangePosition(float wait)
	{
		yield return new WaitForSeconds(wait);

		switch (searchID)
		{
			case 1:
				Player.SendMessage("MoveToPoint", searchPosition);
				searchID = 2;
				break;
			case 2:
				// searchPosition = SearchPoint3.position;
				Player.SendMessage("MoveToPoint", searchPosition);
				searchID = 3;
				break;
			case 3:
				// searchPosition = SearchPoint1.position;
				Player.SendMessage("MoveToPoint", searchPosition);
				searchID = 1;

				if ( !hasFaded )
				{
					Camera.main.GetComponent<CameraFade>().SetScreenOverlayColor(Color.clear);
					Camera.main.GetComponent<CameraFade>().StartFade(Color.black, 15f);
					Camera.main.GetComponent<Title>().fadeMusicOut = true;
					Camera.main.GetComponent<Title>().showCredit = true;
					hasFaded = true;
				}
				break;
			default:
				Debug.Log("Something broke");
				break;
		}
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			if ( !Camera.main.GetComponent<GameMenu>().searchHideSeek )
			{
				Player.SendMessage("SetTextDelay", 3);
				Player.SendMessage("SetTextDuration", 5);
				Player.SendMessage("UpdateText", "< I wonder if sheep is where\nwe play hide and seek . . . >");
			}
			else if ( !Camera.main.GetComponent<GameMenu>().searchRace )
			{
				Player.SendMessage("SetTextDelay", 2);
				Player.SendMessage("SetTextDuration", 5);
				Player.SendMessage("UpdateText", "< I wonder if sheep is\nby the ocean . . . >");
			}
			else if ( Camera.main.GetComponent<GameMenu>().searchHideSeek && Camera.main.GetComponent<GameMenu>().searchRace )
			{
				GameOver = true;

				Player.SendMessage("MoveToPoint", searchPosition);

				Camera.main.GetComponent<Controller>().canControl = false;
				Camera.main.GetComponent<Controller>().follow = false;
				Camera.main.transform.position = TeleportPoint.position;
			}
		}
	}
}
