using UnityEngine;
using System.Collections;

public class Intro : MonoBehaviour {

	GameObject Player;
	GameObject Sheep;

	// Use this for initialization
	void Start ()
	{
		Player = GameObject.Find("Player");
		Sheep = GameObject.Find("Sheep");

		Sheep.SendMessage("SetMoveState", false);
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" )
		{
			Sheep.SendMessage("SetMoveState", true);
			Sheep.SendMessage("MoveToPoint", Vector3.zero);
			Player.SendMessage("SetMoveState", false);

			Camera.main.GetComponent<Controller>().canControl = false;

			string sheepText = "";

			switch (Camera.main.GetComponent<GameMenu>().gameState)
			{
				case 0:
					sheepText = "Good morning, peach!";
					break;
				case 1:
					sheepText = "Good morning, peach . . .";
					break;
				case 2:
					sheepText = "What is it, peach . . .";
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			Sheep.SendMessage("SetTextDelay", 0f);
			Sheep.SendMessage("SetTextDuration", 2.5);
			Sheep.SendMessage("UpdateText", sheepText);

			Player.SendMessage("SetTextDelay", 3);
			Player.SendMessage("SetTextDuration", 2.5);
			Player.SendMessage("UpdateText", "What should we do today, sheep?");

			collider.enabled = false;

			StartCoroutine(DisplayMenu(6f));
		}
	}

	IEnumerator DisplayMenu(float wait)
	{
		yield return new WaitForSeconds(wait);
		Camera.main.GetComponent<GameMenu>().showMenu = true;
	}
}
