using UnityEngine;
using System.Collections;

public class SearchTrigger : MonoBehaviour {

	bool allowTalk = true;
	GameObject Player;

	// Use this for initialization
	void Start () {
		allowTalk = true;
		Player = GameObject.Find("Player");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter (Collider other)
	{
		if ( other.gameObject.tag == "Player" && allowTalk )
		{
			string text = "";
			
			switch ( Mathf.RoundToInt(Random.value * 3) )
			{
				case 0:
					text = ". . . Sheep?";
					break;
				case 1:
					text = "Where are you, sheep?";
					break;
				case 2:
					text = "Sheep, are you here?";
					break;
				case 3:
					text = "I have some flowers for you, sheep!";
					break;
				default:
					Debug.Log("Something broke");
					break;
			}

			Player.SendMessage("SetTextDelay", 1f);
			Player.SendMessage("SetTextDuration", 2.5f);
			Player.SendMessage("UpdateText", text);

			allowTalk = false;

			StartCoroutine(EnableTalk(5f));
		}
	}

	IEnumerator EnableTalk(float wait)
	{
		yield return new WaitForSeconds(wait);
		allowTalk = true;
	}
}
